<?php
/**
*
* @package VC
* @version $Id: captcha_modern.php $
* @copyright (c) 2009 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/


/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
 * 
 * captcha modren
 * @author abd allatif eymsh
 * 
 */


class captcha
{
	var $dir;
	var $font_dir;
	var $width = 360;
	var $height = 96;

	var $difficulty;
	var $angle;
	var $useimage;
	var $random_chars;


	/**
	* captcha::captcha()
	* constructor
	*
	*/

	function captcha()
	{

		global $phpbb_root_path , $config;


		//set paths for images and fonts

		$this->dir = $phpbb_root_path. 'images/regimage/images';
		$this->font_dir = $phpbb_root_path. 'images/regimage/fonts';

		$this->difficulty = $config['captcha_modern_difficulty'];
		$this->useimage = $config['captcha_modern_use_image'];

		if ($config['captcha_modern_random_chars'] <= 500 AND $config['captcha_modern_random_chars'] >= 100)
		{
			$this->random_chars = $config['captcha_modern_random_chars'];
		}else
		{
			$this->random_chars = 250;
			$config['captcha_modern_random_chars'] = 250;
		}
		
		if ($config['captcha_modern_random_chars'] == 0 OR $config['captcha_modern_use_image'] == true)
		{
			$this->random_chars = 0;

		}
		switch ($this->difficulty)
		{
			case '1' :

			$this->angle = array(-30 ,30);
			break;
			
			case '2' :

			$this->angle = array(-40 ,40);
			break;
			
			case '3' :

			$this->angle = array(-60 ,60);
			break;
			
			default :

			$this->angle = array(-40 ,40);
			break;
		}
	}

	/**
	* captcha::execute()
	* output captcha image
	* @param $code the code that will display in the image
	* @param $seed
	* 
	*/
	
	function execute($code, $seed)
	{
		
		global $config;

		mt_srand($seed);

		//read images dir

		$images = $this->read_dir($this->dir, array('jpg', 'jpeg', 'png'));
		$useable_images = array();

		foreach ($images as $the_image)
		{

			$image_info = getimagesize($this->dir.'/'.$the_image);
			if($image_info[0]>350 AND $image_info[1]>90 AND $image_info[0]<400 AND $image_info[1]<100)
			{
				array_push($useable_images, $the_image);
			}

		}

			if (function_exists(imagecreatetruecolor))
			{
				//create image in GD2

				$image = imagecreatetruecolor($this->width, $this->height);

				//back-ground color
				$bgcolor = imagecolorallocate($image, 244, 244, 244);
				imagefill ($image, 0, 0, $bgcolor);

				$image_info = array($this->width, $this->height);
			}else
			{
				//for GD

				$image = imagecreate($this->width,$this->height);

				$bgcolor = imagecolorallocate($image, 244, 244, 244);
				$image_info = array($this->width, $this->height);
			}

			if (count($useable_images) != 0 AND $this->useimage == true)
			{

				if (count($useable_images) == 1)
				{
					//only one image in the dir

					$src_image = $useable_images[0];
					$image_ext_value = $this->get_extension($this->dir.'/'.$src_image);
					$image_info = getimagesize($this->dir.'/'.$src_image);

				}else
				{
					//more than one image

					$random_image = array_rand($useable_images,2);
					$src_image = $useable_images[$random_image[0]];
					$image_ext_value = $this->get_extension($this->dir.'/'.$src_image);
					$image_info = getimagesize($this->dir.'/'.$src_image);

				}

				//check image extension

				if ($image_ext_value == 'jpg' OR $image_ext_value == 'jpeg')
				{

					$imagesrc = imagecreatefromjpeg ($this->dir.'/'.$src_image);
					$imagesrc_info = getimagesize ($this->dir.'/'.$src_image);

					imagecopyresized ($image, $imagesrc,0, 0, 0, 0, $this->width,
							$this->height, $imagesrc_info[0], $imagesrc_info[1]);

				}

				elseif ($image_ext_value == 'png')
				{

					$imagesrc = imagecreatefrompng($this->dir.'/'.$src_image);
					$imagesrc_info = getimagesize($this->dir.'/'.$src_image);

					imagecopyresized($image, $imagesrc, 0, 0, 0, 0, $this->width,
							$this->height, $imagesrc_info[0], $imagesrc_info[1]);

				}

		}

		//print the code
		$this->output_text($image, $image_info, $code, $this->random_chars);

		//output the image and set the headers

		header('Content-Type: image/png');
		header('Cache-control: no-cache, no-store');
		imagepng($image);
		imagedestroy($image);

	}

  /**
	* captcha::output_text()
	* print the code in the image
	* @param object $image
	* @param mixed $image_info
	* @param string $code
	* @param integer $back_num
	*
	*/

	function output_text($image, $image_info, $code ,$back_num)
	{

		if(function_exists(imagettftext))
		{

			$fonts = $this->read_dir($this->font_dir,array('ttf'));

			if (count($fonts) == 0)
			{
				//no TrueType font so print it without TTF font

				$this->text_gd($image, $code , $image_info);

			}else
			{

				for($back_chars = 0; $back_chars < $back_num/ strlen($code); $back_chars++)
				{
					//make random chars
					$fonts = $this->read_dir($this->font_dir, array('ttf'));

					if (count($fonts) == 1)
					{
						$font = $this->font_dir.'/'.$fonts[0];

					}else
					{

						$random_font = array_rand($fonts,2);
						$font = $this->font_dir.'/'.$fonts[$random_font[0]];

					}

					//make random color, angle and position

					$sh_angle = rand(0,360);
					$sh_color = imagecolorallocate($image,rand(160,220),rand(160,220),rand(160,220));
					$x_pos = rand(0, $image_info[0]);
					$y_pos = rand(0, $image_info[1]);

					imagettftext($image, $image_info[1]/10, $sh_angle, $x_pos, $y_pos, $sh_color, $font,rand(1,512));

				}

				//and now the code itself

				$pos_x = -35;
				for ($counter = 0; $counter < strlen($code); $counter++)
				{
					$fonts = $this->read_dir($this->font_dir, array('ttf'));

					if (count($fonts) == 1)
					{

						$font = $this->font_dir.'/'.$fonts[0];

					}else
					{

						$random_font = array_rand($fonts,2);
						$font = $this->font_dir.'/'.$fonts[$random_font[0]];

					}

					$fontcolor = imagecolorallocate($image,rand(50,150),rand(50,150),rand(50,150));
					$pos_x = ($pos_x + $image_info[0] / strlen($code) ) -3 ;
					$pos_y = rand(($image_info[1] / 2) + ($image_info[1] * 20)/100 ,($image_info[1] / 2)+($image_info[1] * 30)/100);
					$angle = rand($this->angle[0], $this->angle[1]);
					imagettftext($image, rand(($image_info[0]/10),($image_info[0]/10)+20), $angle, $pos_x, $pos_y,
							$fontcolor, $font, $code[$counter]);

				}
			}

		}else
		{
			//TrueType is not supported

			$this->text_gd($image, $code ,$image_info);
		}

	}

	/**
	* captcha::text_gd()
	* output the text with GD fonts
	* @param object $image
	* @param string $code
	* @param mixed $image_info
	* 
	*/

	function text_gd($image, $code, $image_info)
	{

		$fonts = $this->read_dir($this->font_dir, array('gdf'));

		if (count($fonts) == 0)
		{

			$font = 5;		//size of the font

		}else
		{
			//there is a font , load it
			$font_name = $this->font_dir.'/'.$fonts[0];
			$font = imageloadfont($font_name);

		}

		$fontcolor = imagecolorallocate($image, rand(50,150), rand(50,150), rand(50,150));
		$pxcolor = imagecolorallocate($image, 100, 200, 0);		//NOISE color

		for ($i = 1; $i < 250; $i++)
		{
			//make random PXs

			$x_num = rand(0, $image_info[0]);
			$y_num = rand(0, $image_info[1]);
			imagesetpixel($image, $x_num, $y_num, $pxcolor);

		}

		$pos_x = -20;
		for ($counter = 0; $counter < strlen($code); $counter++)
		{

			$pos_x = $pos_x + $image_info[0] / strlen($code) -4;
			$pos_y = rand(($image_info[1] / 2) -20,($image_info[1] / 2) +10);

			imagestring($image, $font, $pos_x, $pos_y, $code[$counter], $fontcolor);

		}

	}

	/**
	* captcha::get_extension()
	*	get the extension for a file
	* @param string $item
	* @return string file extension
	*/

	function get_extension($item)
	{

		$file_extension = explode('.',$item);
		$file_ext_count = count($file_extension) -1;
		$file_ext_value = strtolower($file_extension[$file_ext_count]);

		return $file_ext_value;
	}

	/**
	* captcha::read_dir()
	*	read all files in the dir and add them to an array
	* @param string $dir_name
	* @param mixed $extensions
	* @return array $files
	*/

	function read_dir($dir_name,$extensions)
	{

		$files = array();
		$dir_open = @opendir($dir_name);

		while ($file = @readdir($dir_open))
		{

			if ($file!='.' AND $file!='..')
			{

				$file_extension = $this->get_extension($file);

				foreach ($extensions as $the_exts)
				{
					if ($the_exts==$file_extension) 		//add the file to our array
					{
						array_push($files,$file);
					}
				}
			}
		}
		@closedir ($dir_open);

		return $files;

	}


}

//end of the class captcha

?>