<?php
/**
*
* @package VC
* @version $Id: phphbb_captcha_modern_plugin.php $
* @copyright (c) 2009 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Placeholder for autoload
*/

if (!class_exists('phpbb_default_captcha'))
{
	include($phpbb_root_path . 'includes/captcha/plugins/captcha_abstract.' . $phpEx);
}

class phpbb_captcha_modern extends phpbb_default_captcha
{
	
	var $captcha_vars = array(
		'captcha_modern_random_chars'				=> 'CAPTCHA_MODERN_RANDOM_CHARS',
		'captcha_modern_difficulty'					=> 'CAPTCHA_MODERN_DIFFICULTY',
		'captcha_modern_use_image'					=> 'CAPTCHA_MODERN_USE_IMAGE'
	
	);


	function phpbb_captcha_modern()
	{

		global $phpbb_root_path, $phpEx;


		if (!class_exists('captcha'))
		{
		
			include_once($phpbb_root_path . 'includes/captcha/captcha_modern.' . $phpEx);
		}
	}

	function get_instance()
	{
		return new phpbb_captcha_modern();
	}

	function is_available()
	{
		global $phpbb_root_path, $phpEx;

		if (@extension_loaded('gd'))
		{
			return true;
		}

		if (!function_exists('can_load_dll'))
		{
			include($phpbb_root_path . 'includes/functions_install.' . $phpEx);
			
		}

		return can_load_dll('gd');
	}

	function get_name()
	{
		return 'CAPTCHA_MODERN';
	}

	function get_class_name()
	{
		return 'phpbb_captcha_modern';
	}
	
	function has_config()
	{
		return true;
	}

	function acp_page($id, &$module)
	{
		global $db, $user, $auth, $template;
		global $config;

		$user->add_lang('acp/captcha_modern');

		$config_vars = array(
			'enable_confirm'		=> 'REG_ENABLE',
			'enable_post_confirm'	=> 'POST_ENABLE',
			'confirm_refresh'		=> 'CONFIRM_REFRESH',
			'captcha_gd'			=> 'CAPTCHA_GD',
		);

		$module->tpl_name = 'captcha_modern_acp';
		$module->page_title = 'ACP_VC_SETTINGS';
		$form_key = 'acp_captcha';
		add_form_key($form_key);

		$submit = request_var('submit', '');

		if ($submit && check_form_key($form_key))
		{
			$captcha_vars = array_keys($this->captcha_vars);
			foreach ($captcha_vars as $captcha_var)
			{
				$value = request_var($captcha_var, 0);
				if ($value >= 0)
				{
					set_config($captcha_var, $value);
				}
			}

			add_log('admin', 'LOG_CONFIG_VISUAL');
			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($module->u_action));
		}
		else if ($submit)
		{
			trigger_error($user->lang['FORM_INVALID'] . adm_back_link($module->u_action));
		}
		else
		{
			foreach ($this->captcha_vars as $captcha_var => $template_var)
			{
				$var = (isset($_REQUEST[$captcha_var])) ? request_var($captcha_var, 0) : $config[$captcha_var];
				$template->assign_var($template_var, $var);
			}

			$template->assign_vars(array(
				'CAPTCHA_PREVIEW'	=> $this->get_demo_template($id),
				'CAPTCHA_NAME'		=> $this->get_class_name(),
				'U_ACTION'			=> $module->u_action,
			));
		}
	}

	function execute_demo()
	{
		global $config;

		$config_old = $config;
		foreach ($this->captcha_vars as $captcha_var => $template_var)
		{
				$config[$captcha_var] = request_var($captcha_var, (int) $config[$captcha_var]);
		}
		parent::execute_demo();
		$config = $config_old;
	}

}

?>